Python_Project/Python_Project/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('app/', include('messageApp.urls')),
    path('', include('members.urls')),
    path('items/', include('item_application.urls'))
]

if settings.DEBUG:  # development
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Python_Project/members/urls.py
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView, PasswordChangeView, PasswordChangeDoneView
from django.urls import path
from .views import *

urlpatterns = [
    path('register/', register, name='member-register'),
    path('', index, name='index'),
    path('login/', LoginView.as_view(template_name='members/login.html'), name='login'),
    path('logout/', LogoutView.as_view(template_name='members/logout.html'), name='logout'),
    path('settings/', settings, name='settings'),
    path('password_change/', PasswordChangeView.as_view(template_name='members/reset.html'), name='password_change'),
    path('password_change/done/', PasswordChangeDoneView.as_view(template_name='members/reset2.html'),
         name='password_change_done'),
    path('creators/', creators, name="members_creators",),
    path('userlist/', UserList.as_view(), name="user_list"),
    path('permission_denied/', permission_denied, name="permission_denied")


]

Python_Project/messageApp/urls.py
from django.contrib import admin
from django.urls import path, include, re_path
from .views import *
from . import views

urlpatterns = [
    path('', views.InboxListView),
    path('sendMessage/', sendMessage, name='sendMessage'),
    path('messages/', InboxListView.as_view()),
    path('privateMessage/', InboxDetailView.as_view(),)
]

Python_Project/item_application/models.py
from django.db import models
from members.models import Member
# Create your models here.

class Item(models.Model):
    user = models.ForeignKey(Member, on_delete=models.CASCADE)
    name = models.CharField(max_length=50)
    category = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    pub_date = models.DateField(auto_now_add=True)
    keywords = models.CharField(max_length=100)
    status = models.CharField(max_length=10)
    address = models.CharField(max_length=100)
    price = models.CharField(max_length=10, default="50")
    itempic = models.ImageField(upload_to="itempics", default="default_pics/whatisit.png")

    def __str__(self):
        return self.name

class Comment(models.Model):
    item = models.ForeignKey(Item, on_delete=models.CASCADE)
    user = models.ForeignKey(Member, on_delete=models.CASCADE)
    comment = models.CharField(max_length=200)

Python_Project/members/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Member(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    user_pic = models.ImageField(upload_to="user_pics", default="default_pics/anonymous.png")

    def __str__(self):
        return self.user.username

Python_Project/members/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

#form of what a user has to input when registering
class UserRegistrationForm(UserCreationForm):
    email: forms.CharField(max_length=180)

    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']

Python_Project/members/views.py
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib import messages  # debug, success, error, warning, info
from django.contrib.auth.forms import UserCreationForm
from django.views.generic import ListView
from .forms import UserRegistrationForm
from django.contrib.auth.models import Group
from .models import Member
from django.forms import ModelForm

#returns a form that allows a user to register where they automatically get registered as a Member
def register(request):
    if request.method == 'POST':
        form = UserRegistrationForm(request.POST)
        if form.is_valid():
            user = form.save()
            username = form.cleaned_data.get('username')
            # flash message = one time message after an event

            messages.success(request, 'Congratulations, {0}. You are now a user. Please log in.'.format(username))
            group = Group.objects.get(name='members')
            user.groups.add(group)
            # add the user as a Member
            Member.objects.create(user=user)

            return redirect('index')
    else:
        form = UserRegistrationForm()

    template_name = 'members/register.html'
    context = {'form': form, 'title': 'Register'}
    return render(request, template_name, context)

#returns home page with title
def index(request):
    context = {
        'title': 'Welcome'
    }
    return render(request, "members/index.html", context)
#the form of what to show in the settings
class CusForm(ModelForm):
    class Meta:
        model = Member
        fields = '__all__'
        exclude = ['user']

#returns an html page with the users profile picture and a link to change password
def settings(request):
    member = request.user.member
    form = CusForm(instance=member)
    if request.method == 'POST':
        form = CusForm(request.POST, request.FILES, instance = member)
        if form.is_valid():
            form.save()

    context = {
        'title': 'Settings',
        'form': form

    }

    return render(request, "members/user_settings.html", context)

#return an html page with our names on it
def creators(request):
    context = {
        'title': 'Creators',
    }
    return render(request, "members/creators.html", context)

#lists all the users with different buttons depending on what the people allowed want to do to them
class UserList(LoginRequiredMixin, UserPassesTestMixin, ListView):
    model = User
    template_name = "members/user_list.html"

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data()
        context['title'] = "All Users"
        return context

    def test_func(self):
        return self.request.user.groups.filter(name__in=['admin_Item_gp', 'admin_gp', 'admin_user_gp']).exists()

    def handle_no_permission(self):
        return redirect('permission_denied')

#returns a permission denied message is user isnt allowed
def permission_denied(request):
    context = {'title': 'Access Denied'}
    messages.error(request, "Sorry you don't have authorization to view this page.")
    return render(request, "members/index.html", context)

Python_Project/members/templates/members/creators.html
{% extends "base.html" %}
{% block main_content %}
    <section class="centered">
          <h1>Mikael Baril</h1>
          <h1>Rosemary Canon</h1>
          <h1>Michelle Polonsky</h1>
          <h1>Caelan Whitter</h1>
      </section>
{% endblock main_content %}

Python_Project/members/templates/members/index.html
{% extends "base.html" %}
{% block main_content %}
<section id="home">
    {% load static %}
    <img id="people_shopping" src="{% static 'images/people.jpg' %}" alt="People shopping">
    <section class="centered">
      <h1>Welcome to F18 Marketplace</h1>
      <p>This is some example text</p>
      <p>Buy our stuff and give us your money!!</p>
      <a href="{% url 'item_list' %}" class="explore_button">EXPLORE THINGS</a>
    </section>
</section>
{% endblock main_content %}

Python_Project/members/templates/members/login.html
{% extends "base.html" %}
    {% block main_content %}
        <section class="register-form">
        <form method="POST">
            {% csrf_token %}
            <fieldset>
                <legend>Login</legend>
                {{ form }}
            </fieldset>
            <button type="submit" class="submit">Login</button>
            <p>Sign up <a href ="{% url 'member-register' %}"> here</a> if not yet registered </p>
        </form>
        </section>
    {% endblock main_content %}

Python_Project/members/templates/members/logout.html
{% extends "base.html" %}
{% block main_content %}
    <section class="logout">
        <h3> You are now logged out</h3>
            <p>
                Login again?
                <a href="{% url 'login' %}">Login here</a>
            </p>
            <p>
                No account?
                <a href="{% url 'member-register' %}">Register here</a>
            </p>
    </section>
{% endblock main_content %}

Python_Project/members/templates/members/register.html
{% extends "base.html" %}
    {% block main_content %}
        <section class="register-form">
        <form method="POST">
            {% csrf_token %}
            <fieldset>
                <legend>Sign up</legend>
                {{ form }}
            </fieldset>
            <button type="submit" class="submit">Register</button>
        <p>Login <a href ="{% url 'login' %}"> here</a> if you already have an account</p>
        </form>
        </section>
    {% endblock main_content %}

Python_Project/members/templates/members/reset.html
{% extends 'base.html' %}

{% block main_content %}



<form method="POST" class="reset">
  {% csrf_token %}
  <lengend>Change password</lengend>
    <input name="old_password" placeholder="Old password" required="true" type="password" id="id_old_password" >
    <input name="new_password1" placeholder="New password" required="true" type="password" id="id_new_password1" >
    <input name="new_password2" placeholder="Confirm password" required="true" type="password" id="id_new_password2" >

    {% for field in form %}
      {% for error in field.errors %}
        <p id="reset_error">{{ error }}</p>
      {% endfor %}
    {% endfor %}

  <button type="submit" class="submit">Update</button>
</form>



{% endblock main_content %}

Python_Project/members/templates/members/reset2.html
{% extends 'base.html' %}

{% block main_content %}


	<div>
		<h1 class="update">Your password has been Updated. Go back to <a href="{% url 'settings' %}">Settings</a> or <a href="{% url 'index' %}">Home Page</a></h1>

	</div>


{% endblock main_content%}

Python_Project/members/templates/members/user_list.html
{% extends "base.html"%}
{% block main_content %}
<section id="user_list">
    <h1>All Users</h1>
    <table border="1">
  <tr>
    <th>id</th>
    <th>username</th>
    <th>Groups</th>
    <th>Actions</th>
  </tr>
   {% for o in object_list %}
  <tr>
    <td >{{ o.id }}</td>
    <td >{{ o.username }}</td>
    <td>
        <ul>
        {% for group in o.groups.all %}
        <li>{{ group }} </li>
        {% endfor %}
        </ul>
    </td>
    <td>
        <a class="editBtn" href="">Edit Details</a>
        <a class="modifyBtn" href="">Modify Groups</a>
        <a class="flagBtn" href="">Flag</a>
        <a class="warnBtn" href="">Warn</a>
        <a class="delBtn" href="">Delete</a>
    </td>
   {% endfor %}
  </tr>
</table>
</section>

{% endblock main_content %}

Python_Project/members/templates/members/user_settings.html
{% extends 'base.html' %}

{% block main_content %}
	<div id="change_pic">
		<img id="profile_pic" src="{{ user.member.user_pic.url }}">

		<form method="POST" action="" enctype="multipart/form-data">
			{% csrf_token %}
			{{ form.as_p }}
			<input id="pic_submit" type="submit" name="Update">
		</form>
	</div>
	<h1 class="update"><a href="{% url 'password_change' %}">Update Password</a> </h1>
{% endblock main_content %}